'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _buble = require('buble');

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _util = require('../util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReactPlaygroundBare = function (_React$Component) {
  _inherits(ReactPlaygroundBare, _React$Component);

  function ReactPlaygroundBare() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ReactPlaygroundBare);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ReactPlaygroundBare.__proto__ || Object.getPrototypeOf(ReactPlaygroundBare)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      evalChild: null,
      errorMessage: ''
    }, _this.onUpdateSource = function (source) {
      var _this$props = _this.props,
          scope = _this$props.scope,
          EvalWrapper = _this$props.EvalWrapper,
          useRemoteEval = _this$props.useRemoteEval,
          remoteEvalUrl = _this$props.remoteEvalUrl;
      var _this2 = _this,
          mountNode = _this2.mountNode;

      var useRemote = typeof useRemoteEval === 'function' ? useRemoteEval() : useRemoteEval;
      var compile = useRemote ? _util.remoteCompile : _util.localCompile;
      compile(source, remoteEvalUrl).then((0, _util.evalReact)(scope, mountNode, EvalWrapper)).then(_this.onComponent).catch(function (error) {
        return _this.onError({
          source: source,
          error: error
        });
      });
    }, _this.onComponent = function (evalChild) {
      var EvalWrapper = _this.props.EvalWrapper;
      var _this3 = _this,
          mountNode = _this3.mountNode;

      if (evalChild) {
        _reactDom2.default.unmountComponentAtNode(mountNode);
        _reactDom2.default.render(EvalWrapper ? _react2.default.createElement(
          EvalWrapper,
          null,
          evalChild
        ) : evalChild, mountNode);
      }

      if (_this.mounted === false) return;
      _this.setState({
        evalChild: evalChild,
        errorMessage: ''
      });
    }, _this.onError = function (_ref2) {
      var error = _ref2.error,
          source = _ref2.source;

      var errorMessage = error.message;
      if (_this.mounted === false) return;
      _this.setState({
        errorMessage: (0, _util.formatErrorMessage)({ errorMessage: errorMessage, source: source })
      });
    }, _this.onViewerMount = function (el) {
      if (!(el instanceof Node)) return;
      _this.mountNode = el;
      _this.onUpdateSource(_this.props.defaultValue);
    }, _this.onChange = _this.onUpdateSource, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ReactPlaygroundBare, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.mounted = true;
      this.onUpdateSource(this.props.defaultValue);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.mounted = false;
      _reactDom2.default.unmountComponentAtNode(this.mountNode);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          defaultValue = _props.defaultValue;
      var _state = this.state,
          errorMessage = _state.errorMessage,
          evalChild = _state.evalChild;
      var onChange = this.onChange,
          onViewerMount = this.onViewerMount;

      return children({
        defaultValue: defaultValue,
        onChange: onChange,
        errorMessage: errorMessage,
        evalChild: evalChild,
        onViewerMount: onViewerMount
      });
    }
  }]);

  return ReactPlaygroundBare;
}(_react2.default.Component);

ReactPlaygroundBare.defaultProps = {
  useRemoteEval: /MSIE [6-9]/.test(navigator.userAgent),
  remoteEvalUrl: '/eval'
};
exports.default = ReactPlaygroundBare;