'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatErrorMessage = exports.evalReact = exports.localCompile = exports.remoteCompile = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.evalInContext = evalInContext;

require('isomorphic-fetch');

var _buble = require('buble');

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function evalInContext(js, context) {
  var scope = Object.keys(context).map(function (key) {
    return 'var ' + key + ' = this.' + key + ';\n';
  }).join('');

  return function () {
    return eval(scope + ';\n' + js);
  }.call(context);
}

var remoteCompile = exports.remoteCompile = function remoteCompile(source, url) {
  return fetch(url, {
    headers: {
      Accept: 'application/json',
      'Content-Type': 'application/json'
    },
    method: 'POST',
    body: JSON.stringify({ source: source })
  }).then(function (res) {
    return res.json();
  }).then(function (_ref) {
    var transpiled = _ref.transpiled,
        errorMessage = _ref.errorMessage;

    if (errorMessage !== '') throw new Error(errorMessage);
    return transpiled;
  });
};

var localCompile = exports.localCompile = function localCompile(source) {
  return new Promise(function (resolve, reject) {
    var trans = (0, _buble.transform)(source, {
      objectAssign: 'Object.assign',
      transforms: {
        dangerousTaggedTemplateString: true
      }
    });

    resolve(trans.code);
  });
};

var evalReact = exports.evalReact = function evalReact(scope, mountNode) {
  return function (transpiled) {
    return new Promise(function (resolve, reject) {
      var evaluatedChild = evalInContext(transpiled, _extends({
        React: _react2.default,
        ReactDOM: _reactDom2.default,
        render: _reactDom2.default.render,
        Component: _react2.default.Component,
        mountNode: mountNode
      }, scope));
      resolve(_react2.default.isValidElement(evaluatedChild) ? evaluatedChild : null);
    });
  };
};

var formatErrorMessage = exports.formatErrorMessage = function formatErrorMessage(_ref2) {
  var errorMessage = _ref2.errorMessage,
      source = _ref2.source;

  if (!/\((\d+):(\d+)\)$/.test(errorMessage)) {
    return errorMessage;
  }

  var _errorMessage$match = errorMessage.match(/\((\d+):(\d+)\)$/),
      _errorMessage$match2 = _slicedToArray(_errorMessage$match, 3),
      line = _errorMessage$match2[1],
      char = _errorMessage$match2[2];

  var lines = source.split('\n');
  var spaces = '';
  for (var i = 0; i < char - 1; i++) {
    spaces += ' ';
  }
  var prevLine = lines[line - 2];
  return [prevLine ? lines[line - 2] + '\n' : '', lines[line - 1] + '\n', spaces + '^\n', errorMessage].join('');
};